/* eslint-disable guard-for-in */
/* eslint-disable no-restricted-syntax */
import md5 from 'md5';

const ScarecrowTool = {
  rtrim(str, char) {
    const pos = str.lastIndexOf(char);
    const sonstr = str.substr(0, pos);
    return sonstr;
  },
};

/**
 * 创建签名
 * @param param
 */
function createSign(param) {
  if (!(param instanceof Object)) {
    return false;
  }
  if (!param.randstr) {
    return false;
  }

  if (!param.platform) {
    return false;
  }

  const tempParam = {};
  for (const i in param) {
    if (param[i] !== '' && param[i] !== undefined && param[i] !== null) {
      tempParam[i] = param[i];
    }
  }

  const tempData = {};
  for (const i in tempParam) {
    const token = md5(`${i}_${tempParam[i]}`);
    tempData[token] = i;
  }

  let str = '';
  Object.keys(tempData).sort().forEach((key) => {
    str += `${tempData[key]}=${key}&`;
  });
  str = ScarecrowTool.rtrim(str, '&');
  const baseStr = 'bs:(cijz0Yyx@Tk6"C*Jo>!P2v8npZm]~&G%^<2B';
  str = baseStr + str + baseStr;
  const sign = md5(str);

  return {
    sign,
    param,
  };
}

export default createSign;

// let signInfo = createSign({platform:'h5',randstr:'123',token:"b87c308e6919145ccdee3bf246eedc7b"});
// console.log(signInfo)
